<?php
/**
 * Coppermine 1.6.x Plugin - forum
 *
 * Originally written by foulu (Le Hoai Phuong), eenemeenemuu
 * Updated for 1.6.x by KF
 *
 * @copyright  Copyright (c) 2003-2018 Coppermine Dev Team
 * @license    GNU General Public License version 3 or later; see LICENSE
 *
 * plugins/forum/forum/initialize.php
 * @since  1.6.18
 */

// copyright
$fr_copyright = "<div class=\"footer\" align=\"center\"><a href=\"http://cpgsf.amfcvn.net/forum.php\">Coppermine Simple Forum </a> &#169; <a href=\"http://forum.coppermine-gallery.net/index.php?action=profile;u=3924\">foulu</a> :: Sponsored by <a href=\"http://haophong.vn\">banh xe day tay</a></div>";
$template_footer = str_replace('Coppermine Photo Gallery</a></div>', 'Coppermine Photo Gallery</a></div>' . $fr_copyright, $template_footer);
// REFERER
$CONFIG['referer'] = $REFERER;
// forum prefix - for email ...
$CONFIG['fr_prefix_url'] = $CONFIG['ecards_more_pic_target']. (substr($CONFIG['ecards_more_pic_target'], -1) == '/' ? '' : '/');
// check if forum install - still need core database function
$result = cpg_db_query("SELECT count(*) as count FROM `{$CONFIG['TABLE_PREFIX']}plugins` WHERE path='forum';");
$row    = cpg_db_fetch_row($result);
if ($row[0] != 1) {
    cpg_die(ERROR, Lang::item('error.fr_not_install'), __FILE__, __LINE__);
}

// $query_string = $superCage->server->getRaw('QUERY_STRING');
// echo $query_string;

// get controller & method
$c = $superCage->get->getAlpha('c');
$m = $superCage->get->getRaw('m');
// convert to correct type
$c = strtolower(trim($c));
$m = strtolower(trim($m));
// assign || default
$c = ($c != '') ? $c : 'home';
$m = ($m != '') ? $m : 'index';
// set to config array
$CONFIG['c'] = $c;
$CONFIG['m'] = $m;
// ip to config
$CONFIG['hdr_ip'] = $hdr_ip;
$CONFIG['raw_ip'] = $raw_ip;
// if admin page
if (substr_count($c, 'admin') > 0) {
    if (!GALLERY_ADMIN_MODE) {
        cpg_die(ERROR, Lang::item('error.access_denied'), __FILE__, __LINE__);
    }
}
// convert to file path
$source_file = BASE_DIR.'plugins'.DS.'forum'.DS.'forum'.DS.'sources'.DS.$c.'.php';
// main controller + views
if (file_exists($source_file)) {
    include($source_file);
    $class_name = $c . '_controller';
    if (class_exists($class_name)) {
        $main = new $class_name;
        if (method_exists($main, $m)) {
            $main->$m();
        } else {
            // error
            cpg_die(ERROR, sprintf(Lang::item('error.missing_method'), $m, $c), __FILE__, __LINE__);
        }
    } else {
        // error
        cpg_die(ERROR, sprintf(Lang::item('error.missing_class'), $c), __FILE__, __LINE__);
    }
} else {
    // error
    cpg_die(ERROR, sprintf(Lang::item('error.missing_file'), $source_file), __FILE__, __LINE__);
}
