# /**
# Coppermine 1.6.x Plugin - forum
# 
# Originally written by foulu (Le Hoai Phuong), eenemeenemuu
# Updated for 1.6.x by KF
#
# @copyright  Copyright (c) 2003-2018 Coppermine Dev Team
# @license    GNU General Public License version 3 or later; see LICENSE
#
# plugins/forum/install.sql
# @since  1.6.18
# */
  
CREATE TABLE IF NOT EXISTS `CPG_fr_boards` (
  `board_id` smallint(5) NOT NULL auto_increment,
  `cat_id` tinyint(4) NOT NULL default '0',
  `child_level` tinyint(4) NOT NULL default '0',
  `parent_id` smallint(5) NOT NULL default '0',
  `board_order` smallint(5) NOT NULL default '0',
  `last_msg_id` int(10) NOT NULL default '0',
  `updated_msg_id` int(10) NOT NULL default '0',
  `name` tinytext NOT NULL,
  `description` text NOT NULL,
  `topics` mediumint(8) NOT NULL default '0',
  `posts` mediumint(8) NOT NULL default '0',
  PRIMARY KEY (`board_id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `CPG_fr_categories` (
  `cat_id` tinyint(4) NOT NULL auto_increment,
  `cat_order` tinyint(4) NOT NULL default '0',
  `name` tinytext NOT NULL,
  PRIMARY KEY  (`cat_id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `CPG_fr_message_icons` (
  `icon_id` smallint(5) NOT NULL auto_increment,
  `title` varchar(80) NOT NULL default '',
  `filename` varchar(80) NOT NULL default '',
  `icon_order` smallint(5) NOT NULL default '0',
  PRIMARY KEY (`icon_id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 ;

REPLACE INTO `CPG_fr_message_icons` 
(`icon_id`, `title`, `filename`, `icon_order`) 
VALUES 
(1,  'Post',      'icon1',  0),
(2,  'Smile',     'icon2',  1),
(3,  'Big smile', 'icon3',  2),
(4,  'Angry',     'icon4',  3),
(5,  'Cool',      'icon5',  4),
(6,  'Sad',       'icon6',  5),
(7,  'Wink',      'icon7',  6),
(8,  'Comment',   'icon8',  7),
(9,  'Magnify',   'icon9',  8),
(10, 'Icon',      'icon10', 9),
(11, 'Lamp',      'icon11', 10),
(12, 'Bug',       'icon12', 11),
(13, 'Wheel',     'icon13', 12);

CREATE TABLE IF NOT EXISTS `CPG_fr_messages` (
  `msg_id` int(10) NOT NULL auto_increment,
  `topic_id` mediumint(8) NOT NULL default '0',
  `board_id` smallint(5) NOT NULL default '0',
  `poster_time` int(10) NOT NULL default '0',
  `poster_id` mediumint(8) NOT NULL default '0',
  `modified_id` int(10) NOT NULL default '0',
  `subject` tinytext NOT NULL,
  `poster_name` tinytext NOT NULL,
  `poster_email` varchar(80) NULL default '',
  `poster_ip` tinytext NOT NULL,
  `smileys_enabled` tinyint(4) NOT NULL default '1',
  `modified_time` int(10) NOT NULL default '0',
  `modified_name` varchar(80) NOT NULL default '',
  `body` text NOT NULL,
  `icon` varchar(16) NOT NULL default '1',
  PRIMARY KEY  (`msg_id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `CPG_fr_notify` (
  `user_id` int(10) NOT NULL default '0',
  `topic_id` mediumint(8) NOT NULL default '0',
  `board_id` smallint(5) NOT NULL default '0',
  `send` tinyint(1) NOT NULL default '0'
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `CPG_fr_topics` (
  `topic_id` mediumint(8) NOT NULL auto_increment,
  `is_sticky` tinyint(4) NOT NULL default '0',
  `board_id` smallint(5) NOT NULL default '0',
  `first_msg_id` int(10) NOT NULL default '0',
  `last_msg_id` int(10) NOT NULL default '0',
  `started_member_id` int(8) NOT NULL default '0',
  `updated_member_id` int(8) NOT NULL default '0',
  `poll_id` mediumint(8)  NOT NULL default '0',
  `replies` int(10) NOT NULL default '0',
  `views` int(10) NOT NULL default '0',
  `locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`topic_id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `CPG_fr_badwords` (
  `word_id` int(10) NOT NULL auto_increment,
  `word` varchar(45) NOT NULL default '',
  `replace` varchar(45) NOT NULL default '',
  PRIMARY KEY (`word_id`)
) ENGINE=MyISAM;
# Insert default values
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_avatar_size', 100);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_gap_time', 0);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_guest_browse', 0);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_guest_post', 0);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_hot_topic_msg', 10);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_msg_icons', 1);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_msg_max_size', 0);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_msg_per_page', 15);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_max_word_length', 0);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_signature_max_size', 512);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_time_online_checking', 5);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_title', 'Coppermine Simple Forum');
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_topic_per_page', 20);
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_new_topic_email1', '');
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_new_topic_email2', '');
INSERT IGNORE INTO `CPG_config` (name, value) VALUES ('fr_new_topic_email3', '');


